// WDJ.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "WDJ.h"
#include "WDJDlg.h"
#include "WDJWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Change screen-saver password dialog constants.
static const TCHAR g_KszMprDll[] = TEXT("MPR.DLL");
static const TCHAR g_KszProviderName[] = TEXT("SCRSAVE");
#ifdef UNICODE
static const CHAR g_KszPwdChangePW[] = "PwdChangePasswordW";
#else
static const CHAR g_KszPwdChangePW[] = "PwdChangePasswordA";
#endif

/////////////////////////////////////////////////////////////////////////////
// prototype for the change password procedure
typedef DWORD (FAR PASCAL *PWCHGPROC)(LPCTSTR,HWND,DWORD,LPVOID);

/////////////////////////////////////////////////////////////////////////////
// CWDJApp

BEGIN_MESSAGE_MAP(CWDJApp, CWinApp)
	//{{AFX_MSG_MAP(CWDJApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWDJApp construction

CWDJApp::CWDJApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CWDJApp object

CWDJApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CWDJApp initialization

BOOL CWDJApp::InitInstance()
{
    BOOL bRetVal = FALSE;
	AfxEnableControlContainer();
    SetRegistryKey( "WDJ Screen Saver Examples" );

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

    HWND hWnd = NULL;
    switch (GetStartType(hWnd)) 
    {
        case ScreenSaver: 
        case DemoScreenSaver:
            {
                CWDJWnd* pWnd = new CWDJWnd();
                if (pWnd->Create(hWnd)) 
                {
                    m_pMainWnd = pWnd;
                    bRetVal = TRUE;
                }
                else 
                {
                    delete pWnd;
                }
            }
            break;
        case ConfigureSaver:
			{
				CWDJDlg dlg(CWnd::GetActiveWindow());
				dlg.DoModal();
			}
            break;
        case ChangePassword:
            {
                HINSTANCE mpr = LoadLibrary(g_KszMprDll);
                if(NULL != mpr) 
                {
                    PWCHGPROC pwd = (PWCHGPROC)GetProcAddress(mpr, 
                        g_KszPwdChangePW);
                    if(NULL != pwd) 
                    {
                        pwd(g_KszProviderName, 
                             CWnd::GetActiveWindow()->GetSafeHwnd(),
                             0, NULL);
                    }
                }
                FreeLibrary(mpr);
            }
            break;
    }
	return bRetVal;
}

///////////////////////////////////////////////////////////////////
// CScreenTestApp commands

CWDJApp::StartType 
CWDJApp::GetStartType(HWND& hWnd)
{
    StartType eRetVal = ConfigureSaver;
    CString szCmdLine = m_lpCmdLine;
    if (!szCmdLine.IsEmpty()) 
    {
        int nCheckIndex = 0;
        if (('/' == m_lpCmdLine[0]) || ('-' == m_lpCmdLine[0])) 
        {
            nCheckIndex = 1;
        }
        switch (toupper(m_lpCmdLine[nCheckIndex])) 
        {
            case 'S':
                eRetVal = ScreenSaver;
                break;
            case 'C':
                eRetVal = ConfigureSaver;
                break;
            case 'P':
                {
                    eRetVal = DemoScreenSaver;
                    CString szVal = 
                        szCmdLine.Right(szCmdLine.GetLength() - 
                        (nCheckIndex + 1));
                    szVal.TrimLeft();
                    szVal.TrimRight();
                    hWnd = (HWND)atol(szVal);
                }
                break;
            case 'A':
                eRetVal = ChangePassword;
                break;
            default:
                break;
        }
    }
    return eRetVal;
}
