#include <windows.h>
#include <stdio.h>

HANDLE  hDoneEvent = NULL, hThread = NULL;
DWORD   dwCurrentState;
SERVICE_STATUS_HANDLE  hService;
TCHAR szCurrentUser[MAX_PATH], szDbg[MAX_PATH];;
TCHAR szRegPath[] =
 TEXT("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon");
TCHAR szCaption[] = TEXT("WDJSrvc");

BOOL NotifySCM(DWORD, DWORD, DWORD);
VOID WINAPI ServiceMain(DWORD, LPTSTR *);
VOID WINAPI ServiceHandler(DWORD);
BOOL WINAPI CtrlHandler(DWORD);
DWORD WINAPI WorkerThread(LPVOID);

//-----------------------------------------------------------------
void main(int argc, char **argv)
{
   SERVICE_TABLE_ENTRY ServiceTable[] = {
      {TEXT("WDJSrvc"), ServiceMain}, {NULL, NULL}
   };   
   StartServiceCtrlDispatcher(ServiceTable);
}

//-----------------------------------------------------------------
VOID WINAPI ServiceMain(DWORD dwArgc, LPTSTR *lpszArgv)
{
   DWORD   ThreadId;

   if (!(hService = RegisterServiceCtrlHandler(
         TEXT("WDJSrvc"), ServiceHandler))) {
      return;
   }

   NotifySCM(SERVICE_START_PENDING, 0, 1);

   hDoneEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
   hThread = CreateThread(0,0,WorkerThread,0,0,&ThreadId);

   SetConsoleCtrlHandler(CtrlHandler, TRUE);

   NotifySCM(SERVICE_RUNNING, 0, 0);
   WaitForSingleObject(hDoneEvent, INFINITE);

   CloseHandle(hThread);
   CloseHandle(hDoneEvent);
   return;
}

//--------------------------------------------------------------
VOID WINAPI ServiceHandler(DWORD fdwControl)
{
   switch(fdwControl) {
      case SERVICE_CONTROL_STOP:
         NotifySCM(SERVICE_STOP_PENDING, 0, 1);
         SetEvent(hDoneEvent);
         NotifySCM(SERVICE_STOPPED, 0, 0);
         break;

      case SERVICE_CONTROL_INTERROGATE:
         NotifySCM(dwCurrentState, 0, 0);
         break;

      case SERVICE_CONTROL_SHUTDOWN:
         break;
   }
}

//--------------------------------------------------------------
BOOL NotifySCM(DWORD State, DWORD ExitCode, DWORD Progress)
{
   SERVICE_STATUS ServiceStatus;

   ServiceStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
   ServiceStatus.dwCurrentState = dwCurrentState = State;
   ServiceStatus.dwControlsAccepted = SERVICE_ACCEPT_STOP |
                                      SERVICE_ACCEPT_SHUTDOWN;
   ServiceStatus.dwWin32ExitCode = ExitCode;
   ServiceStatus.dwServiceSpecificExitCode = 0;
   ServiceStatus.dwCheckPoint = Progress;
   ServiceStatus.dwWaitHint = 5000;

   return SetServiceStatus(hService, &ServiceStatus);
}

//-----------------------------------------------------------------
BOOL WINAPI CtrlHandler(DWORD dwCtrlType)
{
   HDESK hDesktop;
   BOOL bSeenFailure = FALSE;

   if (dwCtrlType == CTRL_LOGOFF_EVENT) {
       
       MessageBox(NULL,TEXT("CTRL_LOGOFF_EVENT received"),szCaption,
                  MB_OK|MB_SERVICE_NOTIFICATION);

       while (TRUE) {
           hDesktop = OpenInputDesktop(0, FALSE, 0);
           if (!hDesktop && !bSeenFailure) {
               bSeenFailure = TRUE;
           }
           if (hDesktop) {
               CloseDesktop(hDesktop);
               hDesktop = NULL;
               if (bSeenFailure) break;
           }
       }

       MessageBox(NULL,TEXT("Really logged off now."),szCaption,
                  MB_OK|MB_SERVICE_NOTIFICATION);
   }   
   return FALSE; // pass to next handler
}

//-----------------------------------------------------------------
DWORD WINAPI WorkerThread(LPDWORD ThreadParam)
{
   while (TRUE) {                                   
      Sleep(5000);
   }
   return TRUE;
}

